---
title: Klankbord Digest March 2025
published: false
template: newsletter
---

# Klankbord Digest March 2025

## Events

### What's going on in Rotterdam?

{{ events upcoming }}

### You had to be there ...

{{ events passed}}

## On backups

*By Riviera*

On March 8th I left my laptop on suspend for a little bit too long. I
pressed the spacebar and the screen illuminated. Then it crashed. Then
the fan started running on full blast. The LEDs on the function keys
started blinking rapidly yet intermittently. I looked at the manual
for the device. It wasn't clear what was going on. After a bit of
well-timed fiddling with the power button and the emergency reset
button I heard a beep. The computer informed me that the BIOS had been
damaged and was going through a process of self-healing. Did I press
the spacebar too forcibly? Did the machine overheat? I decided
patience was the best policy in this scenario. After some time, it
fixed itself. I was subsequently informed it would be necessary to
update the firmware. That would bring the BIOS back to a recent,
working version. I did so, and then performed a software update.

When setting up my laptop, I installed the boot partition on a
removable USB drive for security reasons. I keep the USB drive on my
physical key ring. This is a good choice but poses a risk which needs
to be mitigated against: it is paramount that the boot partition is
mounted when upgrading pieces of software. This is especially so when
upgrading Linux images. That's because changes are always made to the
initial RAM file system when a new Linux image is installed. The
images, which are the outcome of regenerating the initramfs, are
placed in the boot partition. As I found out, **bad things happen** if
the USB drive containing the boot partition is not mounted when Linux
images are updated.

I was disorientated by the BIOS' self-healing process and overlooked
one key matter. However, I was also alarmed by this and was able to
get a full backup of my home partition. After getting a backup of my
data, I ran the software upgrade, but presumably forgot to mount the
boot partition. As such, the machine's state of homeostasis was short
lived. With 20 lines of code, the entire situation could have been
avoided. But I didn't take that measure, and lost a system because of
it.

This episode brought my attention to the importance of backups. In
short, I'm planning to upgrade the processor in the Klankschool Server
in April or May during one of the repair cafe evenings. Prior to
undertaking this task, I intend to create a backup of data on the
machine. More specifically, I want to run regular backups using either
`duplicity`, `restic` or `borg`. FTP could be a practical way of doing
this over the internet with a bit of configuration.

There are lots of Routers at CATU running Openwrt. I believe it is
possible to attach a Hard Drive to these routers via USB and use it as
a Network Attached Storage device. Alternately, Rosa found a NAS
device in the trash so perhaps that could be used instead. On par it
would be pragmatic to use a router as a backup system, rather than
setting up another computer to do this. Knoflook has been attempting
to set up a Cisco switch to enhance the network infrastructure in the
building.

In other news, the calendar is kicking off but there's a configuration
issue. For two reasons, therefore, I think it will be necessary to
re-introduce containers on the Klankschool server. The first reason is
that, along with my laptop crashing, a Gitea runner went offline. The
gitea runner was used in tandem with the Klankschool website to keep
it in sync with the Gitea repository. If containers are re-introduced
on the server it will be possible to containerised the Gitea
runner. For some reason, it is not possible to run the runner when the
Gitea instance is running. Secondly, Containerising the Gancio
(calendar) instance will allow for resolving the configuration issue.
